
from scipy import *
from pylab import *
import time


NumSteps = 1000
length = 30

P = zeros((length+1))

def analytic(t):
    # p contains the separation of variables solution as a sum over modes
    p = zeros(length+1)
    sign = 1
    for n in range(1,length):
    #   The amplitude of the nth mode oscillates in sign:
        sign *= -1
    #   This contains the nth term
        p #+= exp(t*stuff involving n and length)*sign*(coefficient to calculate)*sin(x*n*pi/length) 
    #   Add the steady state solution
    p += x/(1.0*length)
    return p
        

ion()
x = array([x for x in range(length+1)])
for i in range(NumSteps):
#   A. Evolution of the diffusion equation.
    P[1:-1] = 0.5*(P[2:] + P[0:-2])
    P[0] = 0
    P[-1] = 1
    cla()
#    time.sleep(0.5)
    plot(x,P,x,analytic(i))
    draw()
    pause(0.001)


show()
