
from scipy import *
from pylab import *
import pylab

def fold(x):
    if x < n2:
         return x
    else:
         return n-x


#read in image info
#signal1 is what we want:
signal1 = imread("sample_image.png")
#fft it:
Ck = fft2(signal1)
#scale it to something sensible:
norm = 1.0/Ck[1,1]
Ck = Ck*norm


n = len(signal1)
print("size of input array", shape(signal1))

#create filter
Filter  = zeros((n,n))
#you'll want to try changing this cutoff frequency. Note the units: frequency go from 0 to n.
cutoff = 4.
cutoffsq = cutoff**2
n2 = n//2
for kx in range(n): 
   for ky in range(n): 
       ksq = fold(kx)**2+fold(ky)**2
       Filter [kx,ky] # = some function of ksq, and cutoffsq



#Filter signal
reconstrk = Ck*Filter 



colormap = pylab.cm.gist_gray
#go back to real space and show picture
imshow(real(ifft2(reconstrk)), interpolation="nearest", cmap=colormap)
   
show()
