#ifndef TENSION_H
#define TENSION_H

#include "Vect3d.h"

using namespace std;

class Tension{
   protected:
   int n;
   vect_f * delta;
   vect_f  * vrhs;
   double * T;
   double * a, * b, * c;
   double  * rhs;
   double StepLengthSq;
   double Damping;
   public:
   Tension(int n, double StepLength, double Damping);
   virtual double * calcTension(vect_f * r, vect_f * f, vect_f * v); 
   vect_f * calcForce(vect_f * r, vect_f * f, vect_f * v);
   double * getTension();
   void tridag();
};

#endif// TENSION_H
