#include <iostream>
#include <math.h>
#include "TensionDamped.h"


double * TensionDamped::calcTension(vect_f * r, vect_f * f, vect_f * v) {
   int i;
   for(i=0; i < n; i++) {
      delta[i] = r[i+1]-r[i];
      b[i] = -2.0*delta[i]*delta[i];
   }
   for(i=1; i < n; i++) {
      a[i] = delta[i]*delta[i-1];
   }
    for(i=0; i < (n-1); i++) {
      c[i] = delta[i]*delta[i+1];
   }

   for(i=0; i < n; i++) {
      rhs[i] = (f[i]-f[i+1])*delta[i] - 100.0*(delta[i]*delta[i]-StepLengthSq);
   }
   tridag();
   return T;
}


