
from scipy import *
from pylab import *


NumSteps = 100000
Seed = 10000
#Seed the random number generator, this is important to understand.
seed(Seed)
length = 10
start = 4
#array holding the total number of visits of a walker to a site at position x
Num = zeros((length+1))
#generate a bunch of random numbers that are either 0 or 1
N_rand = randint(0,2, NumSteps)
#Linear transform the N_rand array so that the numbers are now either -1 or 1:
dir_rand #= involves N_rand and constants
x = start
#An array that will hold all of the escape times
escape_time = array([])

#holds the time a walker has been walking before it is reset
start_time = 0
ave_esc_time = 0

for i in range(NumSteps):
#   take a random step:
    x #+=  take a random step of +1 or -1 using an array from above at index i
    start_time += 1
#   It hits an end:
    if x == length or x == 0:
        x=start
#       This is how you add a value to the end of an array:
        escape_time = append(escape_time,start_time)
        ave_esc_time += start_time
        start_time = 0
    Num[x] += 1


p = Num/Num[start]
plot(p)

ave_esc_time *= 1.0/escape_time.size
print("start position = ", start, "ave escape time = ", ave_esc_time)
show()

